<template>
  <form class="flex flex-col mt-8 border-t border-b pt-4 pb-4" @submit.prevent="validateAndProcess">
    <span class="font-bold italic text-base">{{ goalModel.label }}:</span>
    <input v-model="goalModel.name" type="text" class="mt-3 w-full bg-gray-100 p-1" required>
    <textarea v-model="goalModel.description" class="mt-3 w-full h-32 mt-2 bg-gray-100 p-1" required />
    <div class="mt-3 flex">
      <button-save class="ml-auto" />
    </div>
  </form>
</template>

<script>
import GoalModel from '~/models/Goal'
import ButtonSave from '~/components/buttons/Save'

export default {
  components: {
    ButtonSave
  },

  props: {
    process: {
      type: Function,
      default: (model) => {}
    },
    goal: {
      type: Object,
      default () {
        return new GoalModel()
      }
    }
  },

  data () {
    const goalModel = Object.assign(new GoalModel(), this.goal)

    return {
      goalModel
    }
  },

  methods: {
    validateAndProcess () {
      if (this.goalModel.validate()) {
        this.process(this.goalModel)
      }
    }
  }
}
</script>
